#include <iostream>
#include "Evalutor.h"
#include <math.h>

using namespace std;

ErrInf* u_pow(int* params, WORD par_count,int*ret);
ErrInf* u_sqrt(int* params, WORD par_count,int*ret);
ErrInf* u_exp(int* params, WORD par_count,int*ret);

void main()
{
	char w;
	char* str=(char*)malloc(255);
	cout<<"We run....\n";
	cout<<"Enter expression:";
	cin>>str;
	Evalutor call;
	call.str=str;
	int e;
	call.Parse();
	if(call.err)
		cout<<">>Parse error #"<<call.err->Num<<"<"<<call.err->Description<<">\n";
	else
	{
		UserDefinedFuncDef u_Def;

		u_Def.name="pow";
		u_Def.addr=u_pow;
		call.FuncDefs.push_back(u_Def);

		u_Def.name="sqrt";
		u_Def.addr=u_sqrt;
		call.FuncDefs.push_back(u_Def);

		u_Def.name="exp";
		u_Def.addr=u_exp;
		call.FuncDefs.push_back(u_Def);

		call.ExtractSymbols();
		cout<<"Variables found: "<<call.CountVariables()<<endl;
		for(UINT i=0;i<call.CountVariables();i++)
		{
			int val;
			cout<<"Variable "<<call.GetVariable(i)->name<<":";
			cin>>val;
			call.GetVariable(i)->value=val;
		}
		call.ResolveSymbols();
		if(call.err)
			cout<<">>Resolve symbols error #"<<call.err->Num<<"<"<<call.err->Description<<">\n";
		else
		{
			e=call.Evalute();
			if(call.err)
				cout<<">>Evalute error #"<<call.err->Num<<"<"<<call.err->Description<<">\n";
			else
				cout<<"Result: "<<e<<endl;
		}
	}
	cout<<"We ends";
	cin>>w;
}

ErrInf* u_pow(int* params, WORD par_count,int*ret)
{
	if(par_count!=2)
	{
		ErrInf* ret=new ErrInf;
		ret->Description="Invalid parametrs count";
		ret->Num=ERR_INVALID_PARAMS_COUNT;
		return ret;
	}
	double x=*params;
	*ret=pow(x,*(params+1));
	return (ErrInf*)1;
}

ErrInf* u_sqrt(int* params, WORD par_count,int*ret)
{
	if(par_count!=1)
	{
		ErrInf* ret=new ErrInf;
		ret->Description="Invalid parametrs count";
		ret->Num=ERR_INVALID_PARAMS_COUNT;
		return ret;
	}
	double x=*params;
	if(x<0)
	{
		ErrInf* ret=new ErrInf;
		ret->Description="Sqrt can't call argument lesser zero";
		ret->Num=ERR_INVALID_PARAM;
		return ret;
	}
	*ret=sqrt(x);
	return (ErrInf*)1;
}

ErrInf* u_exp(int* params, WORD par_count,int*ret)
{
	if(par_count!=1)
	{
		ErrInf* ret=new ErrInf;
		ret->Description="Invalid parametrs count";
		ret->Num=ERR_INVALID_PARAMS_COUNT;
		return ret;
	}
	double x=*params;
	*ret=exp(x);
	return (ErrInf*)1;
}